Index: /LMDZ4/trunk/libf/phylmd/thermcell_old.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/thermcell_old.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/thermcell_old.F	(revision 1403)
@@ -112,4 +112,7 @@
       character (len=10) :: str10
 
+      character (len=20) :: modname='thermcell2002'
+      character (len=80) :: abort_message
+
       LOGICAL vtest(klon),down
 
@@ -336,5 +339,5 @@
             if(w2di.eq.2) then
                entr(ig,k)=entr(ig,k)+
-     s         ptimestep*(zzz-entr(ig,k))/float(tho)
+     s         ptimestep*(zzz-entr(ig,k))/REAL(tho)
             else
                entr(ig,k)=zzz
@@ -379,5 +382,4 @@
 c     print*,'ig,l+1,ztv(ig,l+1)'
 c     print*, ig,l+1,ztv(ig,l+1)
-c        stop'dans thermiques'
 c     endif
                zw2(ig,l+1)=2.*RG*(ztv(ig,l)-ztv(ig,l+1))/ztv(ig,l+1)
@@ -395,5 +397,4 @@
 c     print*,'Tv ',(ztv(ig,ll),ll=1,klev)
 c     print*,'Entr ',(entr(ig,ll),ll=1,klev)
-c        stop'dans thermiques'
 c     endif
                ztva(ig,l)=(fmc(ig,l)*ztva(ig,l-1)+entr(ig,l)*ztv(ig,l))
@@ -517,6 +518,7 @@
          do ig=1,ngrid
             if(fracd(ig,l).lt.0.1) then
-               stop'fracd trop petit'
-            else
+              abort_message = 'fracd trop petit'
+              CALL abort_gcm (modname,abort_message,1) 
+           else
 c    vitesse descendante "diagnostique"
                wd(ig,l)=fm(ig,l)/(fracd(ig,l)*rhobarz(ig,l))
@@ -588,6 +590,6 @@
 
       if (w2di.eq.1) then
-         fm0=fm0+ptimestep*(fm-fm0)/float(tho)
-         entr0=entr0+ptimestep*(entr-entr0)/float(tho)
+         fm0=fm0+ptimestep*(fm-fm0)/REAL(tho)
+         entr0=entr0+ptimestep*(entr-entr0)/REAL(tho)
       else
          fm0=fm
@@ -1000,4 +1002,7 @@
       character*2 str2
       character*10 str10
+
+      character (len=20) :: modname='thermcell_cld'
+      character (len=80) :: abort_message
 
       LOGICAL vtest(klon),down
@@ -1855,5 +1860,6 @@
        if (l.eq.klev) then
           print*,'THERMCELL PB ig=',ig,'   l=',l
-          stop
+          abort_message = 'THERMCELL PB'
+          CALL abort_gcm (modname,abort_message,1)
        endif
 !       if ((zw2(ig,l+1).gt.1.e-10).and.(zw2(ig,l).gt.1.e-10).and.
@@ -2164,5 +2170,6 @@
          do ig=1,ngrid
             if(fracd(ig,l).lt.0.1.and.(test(ig).eq.1)) then
-               stop'fracd trop petit'
+              abort_message = 'fracd trop petit'
+              CALL abort_gcm (modname,abort_message,1)
             else
 c    vitesse descendante "diagnostique"
@@ -2262,6 +2269,6 @@
 
       if (w2di.eq.1) then
-         fm0=fm0+ptimestep*(fm-fm0)/float(tho)
-         entr0=entr0+ptimestep*(alim+entr-entr0)/float(tho)
+         fm0=fm0+ptimestep*(fm-fm0)/REAL(tho)
+         entr0=entr0+ptimestep*(alim+entr-entr0)/REAL(tho)
       else
          fm0=fm
@@ -2747,4 +2754,7 @@
       character*10 str10
 
+      character (len=20) :: modname='thermcell_eau'
+      character (len=80) :: abort_message
+
       LOGICAL vtest(klon),down
       LOGICAL Zsat(klon)
@@ -3410,5 +3420,6 @@
          do ig=1,ngrid
             if(fracd(ig,l).lt.0.1) then
-               stop'fracd trop petit'
+              abort_message = 'fracd trop petit'
+              CALL abort_gcm (modname,abort_message,1)
             else
 c    vitesse descendante "diagnostique"
@@ -3481,6 +3492,6 @@
 
       if (w2di.eq.1) then
-         fm0=fm0+ptimestep*(fm-fm0)/float(tho)
-         entr0=entr0+ptimestep*(entr-entr0)/float(tho)
+         fm0=fm0+ptimestep*(fm-fm0)/REAL(tho)
+         entr0=entr0+ptimestep*(entr-entr0)/REAL(tho)
       else
          fm0=fm
@@ -3848,4 +3859,7 @@
       character*10 str10
 
+      character (len=20) :: modname='thermcell'
+      character (len=80) :: abort_message
+
       LOGICAL vtest(klon),down
 
@@ -4394,5 +4408,6 @@
          do ig=1,ngrid
             if(fracd(ig,l).lt.0.1) then
-               stop'fracd trop petit'
+              abort_message = 'fracd trop petit'
+              CALL abort_gcm (modname,abort_message,1)
             else
 c    vitesse descendante "diagnostique"
@@ -4477,6 +4492,6 @@
 cRC
       if (w2di.eq.1) then
-         fm0=fm0+ptimestep*(fm-fm0)/float(tho)
-         entr0=entr0+ptimestep*(entr-entr0)/float(tho)
+         fm0=fm0+ptimestep*(fm-fm0)/REAL(tho)
+         entr0=entr0+ptimestep*(entr-entr0)/REAL(tho)
       else
          fm0=fm
@@ -5257,4 +5272,7 @@
       character*10 str10
 
+      character (len=20) :: modname='thermcell_sec'
+      character (len=80) :: abort_message
+
       LOGICAL vtest(klon),down
 
@@ -5822,5 +5840,6 @@
          do ig=1,ngrid
             if(fracd(ig,l).lt.0.1) then
-               stop'fracd trop petit'
+              abort_message = 'fracd trop petit'
+              CALL abort_gcm (modname,abort_message,1)
             else
 c    vitesse descendante "diagnostique"
@@ -5905,6 +5924,6 @@
 cRC
       if (w2di.eq.1) then
-         fm0=fm0+ptimestep*(fm-fm0)/float(tho)
-         entr0=entr0+ptimestep*(entr-entr0)/float(tho)
+         fm0=fm0+ptimestep*(fm-fm0)/REAL(tho)
+         entr0=entr0+ptimestep*(entr-entr0)/REAL(tho)
       else
          fm0=fm
Index: /LMDZ4/trunk/libf/phylmd/thermcell_out3d.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/thermcell_out3d.h	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/thermcell_out3d.h	(revision 1403)
@@ -27,4 +27,9 @@
          call wrgradsfi(1,nlay,q2(igout,1:klev),'q2       ','q2       ')
 !
+!
+         call wrgradsfi(1,nlay,wthl(igout,1:klev),'wthl       ','wthl       ')
+         call wrgradsfi(1,nlay,wthv(igout,1:klev),'wthv       ','wthv       ')
+         call wrgradsfi(1,nlay,wq(igout,1:klev),'wq       ','wq       ')
+         
          call wrgradsfi(1,nlay,ztva(igout,1:klev),'ztva      ','ztva      ')
          call wrgradsfi(1,nlay,ztv(igout,1:klev),'ztv       ','ztv       ')
@@ -53,5 +58,4 @@
       call wrgradsfi(1,1,f(igout),'f      ','f      ')
       call wrgradsfi(1,1,alim_star_tot(igout),'a_s_t      ','a_s_t      ')
-      call wrgradsfi(1,1,alim_star2(igout),'a_2      ','a_2      ')
       call wrgradsfi(1,1,zmax(igout),'zmax      ','zmax      ')
       call wrgradsfi(1,1,zmax_sec(igout),'z_sec      ','z_sec      ')
